/*
Math3D.cpp
Written by Walter O. Krawec

Copyright (c) 2012 Walter O. Krawec

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include "Math3D.h"

namespace math3D
{
	float CMath3D::FindVectorAngle(math3D::CVector2D pos)
	{
		return 0;
	}

	float CMath3D::FindTileDistanceSq(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, float TileSize)
	{
		// first convert tilse to world positions:
		CVector2D pos1(x1*TileSize, y1*TileSize);
		CVector2D pos2(x2*TileSize, y2*TileSize);

		return FindDistanceSq(pos1, pos2);
	}

	CVector2D math3D::CMath3D::FindRandomPos(const CVector2D& center, float radius)
	{
		// finds a random position within a circle defined by "center" and "radius"
		CVector2D ret;

		ret.x = center.x+(((rand()%200)-100)*(radius/100));
		ret.y = center.y+(((rand()%200)-100)*(radius/100));

		return ret;
	}

	CVector3D math3D::CMath3D::FindRandomPos(const CVector3D& center, float radius)
	{
		// finds a random position within a circle defined by "center" and "radius"
		CVector3D ret;

		ret.x = center.x+(((rand()%200)-100)*(radius/100));
		ret.y = center.y+(((rand()%200)-100)*(radius/100));
		ret.z = center.z+(((rand()%200)-100)*(radius/100));

		return ret;
	}
}